package hu.elte.inf.teralg;

import java.util.Random;

public class Main {

    public static void main(String[] args) {
        double[] array = new double[] { 2, 6, 7, 1, 4, 9, 3, 6, 8, 5 };
        System.out.print("Rendezetlen:");
        for(int i = 0; i < array.length; ++i)
            System.out.print(" " + array[i]);
        System.out.println();

        array = new double[] { 2, 6, 7, 1, 4, 9, 3, 6, 8, 5 };
        Sorts.bubbleSort(array);
        System.out.print("Buborék rendezés:");
        for(int i = 0; i < array.length; ++i)
            System.out.print(" " + array[i]);
        System.out.println();

        array = new double[] { 2, 6, 7, 1, 4, 9, 3, 6, 8, 5 };
        Sorts.insertSort(array);
        System.out.print("Beszúró rendezés:");
        for(int i = 0; i < array.length; ++i)
            System.out.print(" " + array[i]);
        System.out.println();

        array = new double[] { 2, 6, 7, 1, 4, 9, 3, 6, 8, 5 };
        Sorts.maxSort(array);
        System.out.print("Maximum kiválasztó rendezés:");
        for(int i = 0; i < array.length; ++i)
            System.out.print(" " + array[i]);
        System.out.println();

        array = new double[] { 2, 6, 7, 1, 4, 9, 3, 6, 8, 5 };
        Sorts.heapSort(array);
        System.out.print("Kupacrendezés:");
        for(int i = 0; i < array.length; ++i)
            System.out.print(" " + array[i]);
        System.out.println();

        array = new double[] { 2, 6, 7, 1, 4, 9, 3, 6, 8, 5 };
        Sorts.quickSort(array);
        System.out.print("Gyorsrendezés:");
        for(int i = 0; i < array.length; ++i)
            System.out.print(" " + array[i]);
        System.out.println();
        
        // ------------------------------------------
        // MŰVELETIGÉNY TESZT
        // ------------------------------------------
        
        int n = 100000;
        double[] array1 = new double[n];
        double[] array2 = new double[n];
        double[] array3 = new double[n];
        Random rand = new Random();
        
        for(int i = 0; i < array.length; ++i) {
            array1[i] = array2[i] = array3[i] = rand.nextInt(1000000);
        }
        
        System.out.println();
        System.out.println("Műveletigény teszt: " + n + " elem rendezése");
        
        long startTime, elapsedTime;
        startTime = System.currentTimeMillis();
        Sorts.bubbleSort(array1);
        elapsedTime = System.currentTimeMillis() - startTime;
        System.out.println("Buborékrendezés ideje: " + elapsedTime + "ms");
        
        startTime = System.currentTimeMillis();
        Sorts.quickSort(array2);
        elapsedTime = System.currentTimeMillis() - startTime;
        System.out.println("Gyorsrendezés ideje (rekurzív): " + elapsedTime + "ms");
    }
}
